// BMS͗p֐
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "bmsfel_p.h"

#define BUF_SIZE 2048

// staticϐ
namespace {
  // Ԃ\萔
  enum {
    DEFAULT = 1, // s
    COMMENT, // Rgs
    IS_HEADER_OR_BAR, // wb_̃L[ or ߎw

    HEADER_KEY,   // wb_̃L[
    HEADER_SEP,   // wb_̃Zp[^ ' ' or '\t'
    HEADER_VALUE, // wb_̒l

    BAR,          // ߔԍ
    CHANNEL,      // `lԍ
    COLON,        // Ru:v
    OBJECT_ARRAY, // IuWFNgMSB
  };

  int mode;
  FILE *file;
  BmsBms *bms;
  int c;
  char key[BUF_SIZE];
  char value[BUF_SIZE];
  int bar;
  char bar_str[4];
  BmsWord channel;
  char channel_str[3];
  char obj_ary[BUF_SIZE];
  char bar_change[BUF_SIZE];
  // `l"01"̐
  int ch01_count[BmsBar::MAX];

}

namespace BmsLexer {

  int last_error_id = ERR::NONE;
  int last_error_line_num = 0;

  bool _DEFAULT( void );
  bool _IS_HEADER_OR_BAR( void );
  bool _IS_BAR( void );
  bool _HEADER_KEY( void );
  bool _HEADER_SEP( void );
  bool _HEADER_VALUE( void );
  bool _BAR( void );
  bool _CHANNEL( void );
  bool _CHANNEL_BAR_CHANGE( void );
  bool _COLON( void );
  bool _BAR_CHANGE_VALUE( void );
  bool _OBJECT_ARRAY( void );
  // s܂Ői EOFfalseԂ
  bool _GOTO_LINE_END( void );

  //////////////////////////////////////////////////
  // path̃t@CJĉ͂BmsBmsԂ
  // ߂l͐^AsȂU
  bool read_file( char *path, BmsBms **bms_p ) {
    file = NULL;
    bms = NULL_BMS;
    last_error_id = ERR::NONE;

    file = fopen( path, "r" );
    if ( file == NULL ) {
      last_error_id = ERR::FILE_NOT_OPEN;
      goto ERR;
    }
    bms = new BmsBms();
    // `l̐
    for ( int i = 0; i < BmsBar::MAX; ++i ) {
      ch01_count[i] = 0;
    }
    mode = DEFAULT;

    // ͏ߒύX̂݉͂Ă
    last_error_line_num = 1;
    for (;;) {
      switch ( mode ) {
      case DEFAULT:
        if ( _DEFAULT() ) { continue; }
        goto BAR_CHANGE_LEX_END;

      case IS_HEADER_OR_BAR:
        if ( _IS_BAR() ) { continue; }
        break;

      case BAR:
        if ( _BAR() ) { continue; }
        break;

      case CHANNEL:
        if ( _CHANNEL_BAR_CHANGE() ) { continue; }
        break;

      case COLON:
        if ( _COLON() ) { continue; }
        break;

      case OBJECT_ARRAY:
        if ( _BAR_CHANGE_VALUE() ) { continue; }
        break;
      }
      goto ERR;
    }


  BAR_CHANGE_LEX_END:
    // ߂Ēʏ̉
    rewind( file );
    last_error_line_num = 1;
    for (;;) {
      switch ( mode ) {
      case DEFAULT:
        if ( _DEFAULT() ) { continue; }
        goto LEX_END;

      case IS_HEADER_OR_BAR:
        if ( _IS_HEADER_OR_BAR() ) { continue; }
        break;

      case HEADER_KEY:
        if ( _HEADER_KEY() ) { continue; }
        break;

      case HEADER_SEP:
        if ( _HEADER_SEP() ) { continue; }
        break;

      case HEADER_VALUE:
        if ( _HEADER_VALUE() ) { continue; }
        break;

      case BAR:
        if ( _BAR() ) { continue; }
        break;

      case CHANNEL:
        if ( _CHANNEL() ) { continue; }
        break;

      case COLON:
        if ( _COLON() ) { continue; }
        break;

      case OBJECT_ARRAY:
        if ( _OBJECT_ARRAY() ) { continue; }
        break;
      }
      goto ERR;
    }

  LEX_END:
    fclose( file );
    *(bms_p) = bms;
    last_error_id = ERR::NONE;
    return true;

  ERR:
    if ( file != NULL ) { fclose( file ); }
    if ( bms != NULL_BMS ) { delete bms; }
    return false;
  }

  //////////////////////////////////////////////////
  bool _DEFAULT( void ) {
    c = fgetc( file );
    if ( c == '#' ) {
      mode = IS_HEADER_OR_BAR;
      return true;
    }
    if ( c == ' ' || c == '\t' || c == '\n' ) {
      if ( c == '\n' ) { last_error_line_num += 1; }
      return true;
    }
    if ( c != '#' ) {
      return _GOTO_LINE_END();
    }
    last_error_id = ERR::UNKNOWN;
    return false;
  }

  //////////////////////////////////////////////////
  bool _IS_HEADER_OR_BAR( void ) {
    c = fgetc( file );
    if ( isdigit( c ) ) {
      ungetc( c, file );
      mode = BAR;
      return true;
    }
    else if ( isalpha( c ) ) {
      ungetc( c, file );
      mode = HEADER_KEY;
      return true;
    }
    last_error_id = ERR::HEADER_OR_BAR_IS_NOT_DIGIT_OR_ALPHA;
    return false;
  }

  //////////////////////////////////////////////////
  bool _IS_BAR( void ) {
    c = fgetc( file );
    if ( isdigit( c ) ) {
      ungetc( c, file );
      mode = BAR;
      return true;
    }
    mode = DEFAULT;
    return _GOTO_LINE_END();
  }

  //////////////////////////////////////////////////
  bool _HEADER_KEY( void ) {
    for ( int i = 0;; i++ ) {
      key[i] = (char)fgetc( file );
      if ( key[i] == ' ' || key[i] == '\t' || key[i] == '\n' ) {
        if ( key[i] == '\n' ) { last_error_line_num += 1; }
        ungetc( key[i], file );
        key[i] = '\0';
        mode = HEADER_SEP;
        return true;
      }
      else if( !isalnum( key[i] ) ) { break; }
    }
    last_error_id = ERR::INVALID_CHAR_IN_HEADER_KEY;
    return false;
  }

  //////////////////////////////////////////////////
  bool _HEADER_SEP( void ) {
    for (;;) {
      c = fgetc( file );
      if ( c == ' ' || c == '\t' ) { continue; }
      else if ( c == '\n' ) {
        last_error_line_num += 1;
        mode = DEFAULT;
        return true;
      }
      break;
    }
    ungetc( c, file );
    mode = HEADER_VALUE;
    return true;
  }

  //////////////////////////////////////////////////
  bool _HEADER_VALUE( void ) {
    for ( int i = 0;; i++ ) {
      value[i] = (char)fgetc( file );
      if ( value[i] == '\n' ) {
        last_error_line_num += 1;
        value[i] = '\0';
        mode = DEFAULT;

        // WAVo^
        if ( bms->get_wavs()->check_structure( key ) ) {
          if ( bms->get_wavs()->overwrite( key + 3, value ) ){ printf( "wavs overwrite\n"); }
        }
        // BMPo^
        else if ( bms->get_bmps()->check_structure( key ) ) {
          if ( bms->get_bmps()->overwrite( key + 3, value ) ){ printf( "bmps overwrite\n"); }
        }
        // ʏwb_o^
        else{
          bms->get_headers()->store( key, value );
        }

        return true;
      }
      if ( value[i] == EOF ) { break; }
    }
    last_error_id = ERR::EOF_IN_HEADER_VALUE;
    return false;
  }

  //////////////////////////////////////////////////
  bool _BAR( void ) {
    if ( !isdigit( bar_str[0] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    if ( !isdigit( bar_str[1] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    if ( !isdigit( bar_str[2] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    bar_str[3] = '\0';
    mode = CHANNEL;
    return true;

  TAG_ERR:
    last_error_id = ERR::NOT_DIGIT_IN_BAR;
    return false;
  }

  //////////////////////////////////////////////////
  bool _CHANNEL( void ) {
    if ( !isalnum( channel_str[0] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    if ( !isalnum( channel_str[1] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    channel_str[2] = '\0';

    if ( BmsWord( channel_str ) != "02" ) {
      mode = COLON;
    }
    else {
      mode = DEFAULT;
      return _GOTO_LINE_END();
    }
    return true;

  TAG_ERR:
    last_error_id = ERR::NOT_ALNUM_IN_CHANNEL;
    return false;
  }

  //////////////////////////////////////////////////
  bool _CHANNEL_BAR_CHANGE( void ) {
    if ( !isalnum( channel_str[0] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    if ( !isalnum( channel_str[1] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    channel_str[2] = '\0';

    if ( BmsWord( channel_str ) == "02" ) {
      mode = COLON;
    }
    else {
      mode = DEFAULT;
      return _GOTO_LINE_END();
    }
    return true;

  TAG_ERR:
    last_error_id = ERR::NOT_ALNUM_IN_CHANNEL;
    return false;
  }

  //////////////////////////////////////////////////
  bool _COLON( void ) {
    if ( fgetc( file ) != ':' ) { goto TAG_ERR; }
    mode = OBJECT_ARRAY;
    return true;

  TAG_ERR:
    last_error_id = ERR::NOT_COLON_IN_COLON;
    return false;
  }

  //////////////////////////////////////////////////
  bool _OBJECT_ARRAY( void ) {
    if ( !isalnum( obj_ary[0] = (char)fgetc( file ) ) ) { goto TAG_ERR; }
    if ( !isalnum( obj_ary[1] = (char)fgetc( file ) ) ) { goto TAG_ERR; }

    for ( int i = 2;; i += 2 ) {
      c = fgetc( file );
      if ( c == '\n' || c == ' ' || c == '\t' ) {
        // ̋󔒖
        for ( ; c != '\n'; c = fgetc( file ) ) {
          if ( c != ' ' && c != '\t' ) {
            last_error_id = ERR::INVALID_END_IN_OBJECT_ARRAY;
            return false;
          }
        }
        last_error_line_num += 1;
        obj_ary[i] = '\0';
        break;
      }

      if ( !isalnum( c ) ) { goto TAG_ERR; }
      obj_ary[i] = (char)c;

      c = fgetc( file );
      if ( !isalnum( c ) ) { goto TAG_ERR; }
      obj_ary[i + 1] = (char)c;
    }

    bar = atoi( bar_str );
    channel = BmsWord( channel_str );

    // `lԍ"01"͏dȂ̂œȏ
    if ( channel == "01" ) {
      // o^Jnʒu擾
      int to = bms->get_channel_position( bar );
      // ̏߂̒
      int length = bms->bar_at( bar ).get_length_int();

      BmsChannel *temp_channel = bms->get_channel( channel );
      BmsChannel *prev_channel = NULL_CHANNEL;
      for ( int i = 0; i < ch01_count[bar]; ++i ) {
        prev_channel = temp_channel;
        temp_channel = temp_channel->get_same_next();
      }
      ++ch01_count[bar];

      // `lIuWFNg΍ēo^
      if ( temp_channel == NULL_CHANNEL ) {
        temp_channel = new BmsChannel( channel );
        if ( prev_channel == NULL_CHANNEL ) { bms->set_channel( temp_channel ); }
        else { prev_channel->set_same_next( temp_channel ); }
      }

      // IuWF͂ēo^
      int str_position = 0;
      int step = length / ( strlen( obj_ary ) / 2 );
      for ( int i = to; i < to + length; i += step ) {
        temp_channel->overwrite( i, BmsWord( &obj_ary[str_position] ) );
        str_position += 2;
      }
    }
    else { // ʂɓo^
      bms->input_str( bar, channel, obj_ary );
    }

    mode = DEFAULT;
    return true;

  TAG_ERR:
    last_error_id = ERR::INVALID_CHAR_IN_OBJECT_ARRAY;
    return false;
  }

  //////////////////////////////////////////////////
  bool _BAR_CHANGE_VALUE( void ) {
    bool yet_dot = true;

    c = fgetc( file );
    if ( !isdigit( c ) && c != '.' ) {
      last_error_id = ERR::INVALID_VALUE_IN_BAR_CHANGE_VALUE;
      return false;
    }
    if ( c == '.' ) { yet_dot = false; }
    bar_change[0] = (char)c;

    for ( int i = 1;; ++i ) {
      c = fgetc( file );
      if ( isdigit( c ) || ( c == '.' && yet_dot ) ) {
        if ( c == '.' ) { yet_dot = false; }
        bar_change[i] = (char)c;
      }
      else if( c == '\n' ) {
        last_error_line_num += 1;
        bar_change[i] = '\0';
        break;
      }
      else {
        last_error_id = ERR::INVALID_VALUE_IN_BAR_CHANGE;
        return false;
      }
    }

    // ߒo^
    BmsBar current_bar = bms->bar_at( atoi( bar_str ) );
    if ( current_bar.get_length_int() != BmsBar::DEFAULT_LENGTH  ) {
      last_error_id = ERR::DOUBLE_BAR_CHANGE;
      return false;
    }
    current_bar.set( bar_change );
    bms->overwrite_bar_at( atoi( bar_str ), current_bar );

    mode = DEFAULT;
    return true;
  }

  //////////////////////////////////////////////////
  //////////////////////////////////////////////////
  // s܂Ői EOFfalseԂ
  bool _GOTO_LINE_END( void ) {
    for (;;) {
      c = fgetc( file );
      if ( c == '\n' ) {
        last_error_line_num += 1;
        break;
      }
      if ( c == EOF ) {
        last_error_id = ERR::UNEXPECTED_EOF;
        return false;
      }
    }
    return true;
  }

  //////////////////////////////////////////////////
  //////////////////////////////////////////////////
  //////////////////////////////////////////////////

  //////////////////////////////////////////////////
  // path̃t@CJĂɏ
  // ߂l͐^AsȂU
  bool write_file( char *path, BmsBms *bms ) {
    // o͊Jn
    char buf[BUF_SIZE * 3];
    char word_buf[3];
    char header[BUF_SIZE];
    char value[BUF_SIZE];

    FILE *out_file = fopen( path, "w" );
    if ( out_file == NULL ) {
      last_error_id = ERR::FILE_NOT_OPEN;
      return false;
    }

    BmsHeaderHash *header_hash = bms->get_headers()->clone();

    // wb_o
    if ( header_hash->take_str( "TITLE", value ) ) {
      fprintf( out_file, "#%s %s\n", "TITLE", value );
    }
    if ( header_hash->take_str( "GENRE", value ) ) {
      fprintf( out_file, "#%s %s\n", "GENRE", value );
    }
    if ( header_hash->take_str( "ARTIST", value ) ) {
      fprintf( out_file, "#%s %s\n", "ARTIST", value );
    }
    while ( header_hash->shift( header, value ) ) {
      fprintf( out_file, "#%s %s\n", header, value );
    }
    delete header_hash;
    fprintf( out_file, "\n" );

    BmsWord nth;
    // WAVo
    BmsRegistArray *wavs = bms->get_wavs()->clone();
    while ( wavs->shift( &nth, value ) ) {
      fprintf( out_file, "#%s%s %s\n", wavs->get_name(), nth.get_str_null( header ), value );
    }
    delete wavs;
    fprintf( out_file, "\n" );
    // BMPo
    BmsRegistArray *bmps = bms->get_bmps()->clone();
    while ( bmps->shift( &nth, value ) ) {
      fprintf( out_file, "#%s%s %s\n", bmps->get_name(), nth.get_str_null( header ), value );
    }
    delete bmps;
    fprintf( out_file, "\n" );

    // ߃f[^o
    // IuWF݂鏬߂܂ŏo
    int max_bar = bms->get_max_bar();
    for ( int i = 0; i <= max_bar; ++i ) {
      BmsBar current_bar = bms->bar_at( i );
      // ߒύXo
      if ( current_bar.get_length_int() != BmsBar::DEFAULT_LENGTH ) {
        fprintf( out_file, "#%03d%s:%f\n", i, "02", current_bar.get_length_double() );
      }

      // f[^o
      EACH_KIND_CHANNEL( bms->get_first_channel(), temp_channel ) {
        // `lԍ"01"͏dȂ̂œȏ
        if ( temp_channel->get_channel_number() == "01" ) {
          for ( BmsChannel *temp_channel_same = temp_channel; temp_channel_same != NULL_CHANNEL; temp_channel_same = temp_channel_same->get_same_next() ) {
            int to = bms->get_channel_position( i );
            int length = current_bar.get_length_int();

            // ͈͓ɃIuWFĂo͂
            // ΂ԊuvZ
            int step = length;
            for ( int k = 1; k < length; ++k ) {
              if ( temp_channel_same->at( to + k ) != "00" ) {
                step = BmsUtil::gcd( step, k );
              }
            }

            // obt@ɓĂ
            int str_position = 0;
            for ( int k = to; k < to + length; k += step ) {
              temp_channel_same->at( k ).get_str( &buf[str_position] );
              str_position += 2;
            }
            buf[str_position] = '\0';
            fprintf( out_file, "#%03d%s:%s\n",
                     i,
                     temp_channel_same->get_channel_number().get_str_null( word_buf ),
                     buf );
          }
        }
        else {
          // ʂɏo
          int str_len = bms->to_str_null( i, temp_channel->get_channel_number(), buf ) ;
          if ( str_len > 2 || ( str_len == 2 && BmsWord( buf ) != "00" ) ) {
            fprintf( out_file, "#%03d%s:%s\n",
                     i,
                     temp_channel->get_channel_number().get_str_null( word_buf ),
                     buf );
          }
        }
      }
      fprintf( out_file, "\n" );
    }
    // IuWFĂߒύX͂邩Ȃ
    for ( int i = max_bar + 1; i < BmsBar::MAX; ++i ) {
      BmsBar current_bar = bms->bar_at( i );
      if ( current_bar.get_length_int() != BmsBar::DEFAULT_LENGTH ) {
        fprintf( out_file, "#%03d%s:%f\n", i, "02", current_bar.get_length_double() );
      }
    }
    fclose( out_file );
    last_error_id = ERR::NONE;
    return true;
  }


  int get_last_error_id() {
    return last_error_id;
  }
  int get_last_error_line_num() {
    return last_error_line_num;
  }

  const char *id2str( int id ) {
    const char *src = NULL;
    switch ( id ) {
    case ERR::NONE:
      src = "ɏI܂B";
      break;

    case ERR::DOUBLE_BAR_CHANGE:
      src = "ߒύX2w肳܂B";
      break;

    case ERR::EOF_IN_HEADER_VALUE:
      src = "wb_̒l̓rEOFo܂B";
      break;

    case ERR::FILE_NOT_OPEN:
      src = "t@CJ܂łB";
      break;

    case ERR::HEADER_OR_BAR_IS_NOT_DIGIT_OR_ALPHA:
      src = "wb_̃L[⏬ߔԍ̎wɉpȊOw肳܂B";
      break;

    case ERR::INVALID_CHAR_IN_HEADER_KEY:
      src = "wb_̃L[wɕsȕg܂B";
      break;

    case ERR::INVALID_CHAR_IN_OBJECT_ARRAY:
      src = "IuWFzɕsȕg܂B";
      break;

    case ERR::INVALID_END_IN_OBJECT_ARRAY:
      src = "IuWFz񂪐IĂ܂B";
      break;

    case ERR::INVALID_VALUE_IN_BAR_CHANGE:
      src = "ߒύX̏ߔԍw肪słB";
      break;

    case ERR::INVALID_VALUE_IN_BAR_CHANGE_VALUE:
      src = "ߒύX̒lw肪słB";
      break;

    case ERR::NOT_ALNUM_IN_CHANNEL:
      src = "`lԍwɉpȊOg܂B";
      break;

    case ERR::NOT_COLON_IN_COLON:
      src = "߂ƃ`lƒl̊Ԃ̃RɃRgĂ܂B";
      break;

    case ERR::NOT_DIGIT_IN_BAR:
      src = "ߔԍɐgĂ܂B";
      break;

    case ERR::UNEXPECTED_EOF:
      src = "\EOFo܂B";
      break;

    case ERR::UNKNOWN:
    default:
      src = "Ȃ񂩂悭킩ȂǃG[܂B";

    }
    return src;
  }

  const char *get_last_error_str() {
    return id2str( last_error_id );
  }


}
