#include <stdio.h>
#include <time.h>
#include "bmsfel.h"

int main( int argc, char *argv[] ) {

  if ( argc < 2 ) {
    fprintf( stderr, "Usgae : sample <bms file ...>\n", argv[0] );
    return 0;
  }
  for ( int i = 1; i < argc; ++i ) {
    clock_t start_time;
    BmsBms *bms;

    start_time = clock();
    if ( !BmsLexer::read_file( argv[i], &bms ) ) {
      fprintf( stderr, "Error : (line %d) %s\n",
               BmsLexer::get_last_error_line_num(),
               BmsLexer::get_last_error_str() );
      return 1;
    }
    printf( "--%s-------------------------------\n", argv[i] );
    printf( "TITLE       : %s\n", bms->get_headers()->fetch_str( "TITLE" ) );
    printf( "GENRE       : %s\n", bms->get_headers()->fetch_str( "GENRE" ) );
    printf( "ARTIST      : %s\n", bms->get_headers()->fetch_str( "ARTIST" ) );
    printf( "BPM         : %s\n", bms->get_headers()->fetch_str( "BPM" ) );
    printf( "ŏI    : %d\n", bms->get_max_bar() );
    printf( "WAVo^   : %d\n", bms->get_wavs()->get_exist_count() );
    printf( "BMPo^   : %d\n", bms->get_bmps()->get_exist_count() );

    printf( "gpCHANNEL :");
    EACH_KIND_CHANNEL( bms->get_first_channel(), channel ) {
      char buf[3];
      printf( " %s", channel->get_channel_number().get_str_null( buf ) );
    }
    printf( "\n" );

    int object_count = 0;
    EACH_CHANNEL( bms->get_first_channel(), channel ) {
      object_count += channel->get_count();
    }
    printf( "IuWF  : %d\n", object_count );
    
    BmsLexer::write_file( "mokyu.bme", bms );
    delete bms;
    printf( "    : %d\n", clock() - start_time );
    printf( "\n" );
  }
  return 0;
}
